]> git.pld-linux.org Git - packages/rpm.git/blame - rpm.macros
- still needed
[packages/rpm.git] / rpm.macros
CommitLineData
b52fc1f1 1# $Revision$, $Date$
cc2b296f 2# PLD Linux rpm macros
a8bf9720 3
90c0eaed 4%epoch 0
31b569b6 5%x8664 x86_64 amd64 ia32e
63ea47af 6%ppc ppc ppc7400 ppc7450
cd33aab7 7
a544555d 8# kernel compiler
6f86c45e 9%kgcc %{__cc}
cabacfeb 10%kgcc_package gcc
a544555d 11
4343a1f7
ER
12%__rm /bin/rm --interactive=never
13
5f9f9bd7 14# Build system path macros.
15#
8af1c6f5
JB
16%__autoconf autoconf %{?debug:-Wall}
17%__automake automake -a -c -f --foreign
429d047e 18%__autopoint autopoint --force
19
aad1c8e4 20%__gettextize { \
4cd84746 21 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
31b569b6 22 gettextize --copy --force --no-changelog; \
93bce43f 23 else \
31b569b6 24 gettextize --copy --force --no-changelog --intl; \
4cd84746
JB
25 fi; \
26 if [ ! -f po/Makevars ]; then \
31b569b6 27 cp -f po/Makevars{.template,}; \
4cd84746 28 fi; \
4cd84746 29}
429d047e 30
31%__glib_gettextize glib-gettextize --copy --force
32%__gnome_doc_common gnome-doc-common --copy
db1adf13 33%__gnome_doc_prepare gnome-doc-prepare --copy --force
429d047e 34%__gtkdocize gtkdocize --copy
35%__intltoolize intltoolize --copy --force
36%__libtoolize libtoolize --copy --force
5f9f9bd7 37
702e8027
ER
38# Path to top of build area.
39%_topdir %(test -d ../SPECS && (cd ..; pwd) || echo $HOME/rpm)
40
38e780ca
ER
41# The number of cvs changelog entries kept when building package.
42%_buildchangelogtruncate 20
43
bd1cd543 44%dependencytracking %{nil}
31b569b6 45
073ae3ba
ER
46# Relations between package names that cause dependency loops
47# with legacy packages that cannot be fixed. Relations are
48# specified as
49# p>q
50# where package p has a Requires: on something that package q Provides:
51#
52# XXX Note: that there cannot be any whitespace within the string "p>q",
53# and that both p and q are package names (i.e. no version/release).
54%_dependency_whiteout %{nil}
55
9ba56d1b
AM
56%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
57 && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
58 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
cece03f9 59
60#-----------------------------------------------------------------
61#
62# (re)definition of %{rpm*flags} with %filterout_* support
7c9f98ce
ER
63# BuildRequires: awk
64# BuildRequires: rpmbuild(macros) >= 1.315
cece03f9 65#
66# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
a0bf497e 67# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
68# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
69# %rpmldflags = %optldflags - %filterout_ld
cece03f9 70#
71# Regular expressions are supported, but to avoid some character be treated
72# as regular expression it must be escaped twice.
73
74%filter_out \
bf66145e 75 for (i = 1; i in I; i++) { A=0; \
cece03f9 76 for (f in F) { \
77 if (I[i] ~ "^" F[f] "$") A=1; \
78 }; \
79 if (!A) printf(I[i] FS); \
80 }
81
82%rpmcflags %(awk 'BEGIN {
83 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
a0bf497e 84 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
cece03f9 85 %{filter_out}
86}')
87
88%rpmcxxflags %(awk 'BEGIN {
a0bf497e 89 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
90 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
cece03f9 91 %{filter_out}
92}')
93
94%rpmldflags %(awk 'BEGIN {
b699ccff 95 split("%{?optldflags}",I);
cece03f9 96 split("%{?filterout_ld}",F)
97 %{filter_out}
98}')
99
111942c6 100# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
101# but, don't use it, better use gcc as linker
102%ld_rpmldflags %(awk 'BEGIN {
103 split("%{rpmldflags}",F);
104 for (f in F) {
105 s = F[f];
106 if (s ~ /^-Wl,/) {
107 s = substr(s,5);
108 gsub(/,/," ",s);
109 };
110 printf(s FS);
111 };
112}')
113
cd33aab7 114#-----------------------------------------------------------------
9f0287b5 115%configure2_13 { \
cd33aab7
AM
116 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
117 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
118 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
af18d245 119 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
cd33aab7 120 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
d4392e78 121 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
c55f2219 122 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
4eac2e49
AM
123 %{?__cc:CC="%{__cc}" ; export CC ; } \
124 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
5b0f0ac9 125 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
fa74a11c 126 --host=%{_target_platform} \
cd33aab7
AM
127 --prefix=%{_prefix} \
128 --exec-prefix=%{_exec_prefix} \
129 --bindir=%{_bindir} \
130 --sbindir=%{_sbindir} \
131 --sysconfdir=%{_sysconfdir} \
132 --datadir=%{_datadir} \
133 --includedir=%{_includedir} \
134 --libdir=%{_libdir} \
135 --libexecdir=%{_libexecdir} \
136 --localstatedir=%{_localstatedir} \
137 --sharedstatedir=%{_sharedstatedir} \
138 --mandir=%{_mandir} \
139 --infodir=%{_infodir} \
c3420100 140 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 141 %{dependencytracking} \
cd33aab7
AM
142}
143
53c34296
ER
144# override __cmake to add -j4 in your ~/.rpmmacros for parallel make
145%__cmake /usr/bin/cmake
29771119
ER
146%cmake { \
147CC="%{__cc}" \
148CXX="%{__cxx}" \
149CFLAGS="%{rpmcflags}" \
150CXXFLAGS="%{rpmcxxflags}" \
53c34296
ER
151%{__cmake} \
152}
153
154# override __scons to add -j4 in your ~/.rpmmacros for parallel make
155%__scons /usr/bin/scons
156%scons { \
157%{__scons} \
13eb0f84
ER
158 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
159 CFLAGS="${CFLAGS:-%rpmcflags}" \
160 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
161 FFLAGS="${FFLAGS:-%rpmcflags}" \
162 CPPFLAGS="${CPPFLAGS:-}" \
163 %{?__cc:CC="%{__cc}"} \
164 %{?__cxx:CXX="%{__cxx}"} \
165 libsuffix=%{_lib} \
166 prefix=%{_prefix} \
29771119
ER
167}
168
ac093701 169# waf. see waf.spec
53c34296 170# override __waf to add -j4 in your ~/.rpmmacros for parallel make
ac093701
ER
171%__waf /usr/bin/waf
172%waf { \
ac093701
ER
173CC="%{__cc}" \
174CXX="%{__cxx}" \
1624498d 175CPP="%{__cpp}" \
ac093701
ER
176CFLAGS="%{rpmcflags}" \
177CXXFLAGS="%{rpmcxxflags}" \
178%{__waf} \
ac093701
ER
179}
180
85f82bec 181#----------------------------------------------------------------
b7626f51 182#%configure_cache 0
43f81f06 183%configure_cache_file %{buildroot}.configure.cache
7e4e3f2b 184
b8cf6778 185%configure {./configure \
85f82bec
AF
186 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
187 CFLAGS="${CFLAGS:-%rpmcflags}" \
af18d245 188 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
85f82bec 189 FFLAGS="${FFLAGS:-%rpmcflags}" \
d4392e78 190 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
418d9760 191 CPPFLAGS="${CPPFLAGS:-}" \
4eac2e49
AM
192 %{?__cc:CC="%{__cc}"} \
193 %{?__cxx:CXX="%{__cxx}"} \
a9bea0f7 194 --host=%{_target_platform} \
85f82bec
AF
195 --build=%{_target_platform} \
196 --prefix=%{_prefix} \
197 --exec-prefix=%{_exec_prefix} \
198 --bindir=%{_bindir} \
199 --sbindir=%{_sbindir} \
200 --sysconfdir=%{_sysconfdir} \
201 --datadir=%{_datadir} \
202 --includedir=%{_includedir} \
203 --libdir=%{_libdir} \
204 --libexecdir=%{_libexecdir} \
205 --localstatedir=%{_localstatedir} \
206 --sharedstatedir=%{_sharedstatedir} \
207 --mandir=%{_mandir} \
208 --infodir=%{_infodir} \
c3420100 209 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 210 %{dependencytracking} \
b7626f51 211 %{?configure_cache:--cache-file=%{configure_cache_file}} \
85f82bec
AF
212}
213
9cd5fb46
ER
214# overload to insert debuginfo package
215%prep \
216%if 0%{?_enable_debug_packages}\
217%{debug_package}\
218%endif\
219%%prep\
220%{nil}
221
cd33aab7
AM
222# Location of autoconf macros
223%_aclocaldir %(aclocal --print-ac-dir)
224
32720a50
AM
225# Location of omf files
226%_omf_dest_dir %(scrollkeeper-config --omfdir)
227
c5eece2c 228# Location of pkgconfig files
a46897a7 229%_pkgconfigdir /usr/%{_lib}/pkgconfig
c5eece2c 230
c917274d 231# Location of desktop files
232%_desktopdir /usr/share/applications
510f694c 233%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
c917274d 234
fb08fb4a 235# Location of pixmaps for applnk/desktop files
3a9bb008 236%_pixmapsdir /usr/share/pixmaps
cd33aab7 237
fb08fb4a 238# Location of themable icons for applnk/desktop files
986c3bcd 239%_iconsdir /usr/share/icons
240
c5eece2c
JB
241# Location of fonts directories
242%_fontsdir /usr/share/fonts
243
5cfcbc9e 244# Location of Gtk and associated libraries documentation
43f81f06 245%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
5cfcbc9e 246
eee08b2d 247# Location of KDE documentation
43f81f06 248%_kdedocdir %{_defaultdocdir}/kde/HTML
eee08b2d 249
a7cad6ae 250# unsermake script
251%__unsermake /usr/share/unsermake/unsermake
252
cd33aab7
AM
253# Current date
254%date %(LC_ALL="C" date +"%a %b %d %Y")
255
af65e87c
ER
256# tmp directory
257%tmpdir %(echo "${TMPDIR:-/tmp}")
258
cd33aab7
AM
259# Example files, programs, scripts...
260%_examplesdir /usr/src/examples
261
7127e0fc 262# Alternative kernel type/version
c604d0a9 263%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
7127e0fc 264
bd63739a 265# The directory holding Linux kernel sources
c604d0a9 266%_kernelsrcdir /usr/src/linux%{_alt_kernel}
bd63739a 267
cd33aab7 268# If non-empty "debug" macro defined, add "dbg" suffix to release number
5b0f0ac9 269%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
cd33aab7 270
5b0f0ac9 271# Requires name = version-release
48c1bf9f 272%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
511ee4c6 273
48c1bf9f
ER
274%releq_kernel() %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})
275%releq_kernel_up() %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})
276%releq_kernel_smp() %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})
d606f9ca
ER
277%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
278%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
279%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
511ee4c6 280
48c1bf9f
ER
281# XXX: why epoch 0 is stripped?
282%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
283%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
e478b9e7 284
4ca2266c 285%apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
8dea1306 286
287# kernel version-release handling
1b00eeba 288%__kernel_ver %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
48c1bf9f
ER
289%__kernel_rel %(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not")
290%__kernel_rpmvr %(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not")
31b569b6 291%_kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
066309eb 292%_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
fd4d8ee0 293
c2c27a5a 294# sgml macros
31b569b6
ER
295%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
296%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
297%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
298%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
299%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
300%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
c2c27a5a 301%docbook_sgmlcat_fix() { for l in \
302'' \
303' -- default decl --' \
304'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
305' -- hacks for opensp --' \
306'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
307'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
308'' \
309; do echo $l; done >> %1 \
310}
311
31bd34a8
ER
312# vim - "
313
f3f40db8
ER
314# minimum file size needed for compressed documents.
315# just smaller files than this get larger when compressed.
cdbfc157
ER
316# some stats:
317# - 0 byte file compressed was 25 bytes .gz
318# - 39 byte file was compressed as 57
319# - with test/test.spec@man 158 byte file was compressed also 158
320%_min_compress_bytes 159
f3f40db8 321
cd33aab7
AM
322#-----------------------------------------------------------------
323# find and gzip all files in %{_mandir} and %{infodir}
324#
325# Requires: xargs, find
326#
327#%no_install_post_compress_docs 1
328%__spec_install_post_compress_docs { \
f67bd19e 329%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
026ed59b 330 for i in /usr/share/man /usr/X11R6/man; do \
cd33aab7 331 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
026ed59b 332 echo "Compress man pages: $i"; \
f3f40db8
ER
333 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
334 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
38e531f0
ER
335 find $RPM_BUILD_ROOT$i -type l | while read a; do \
336 m=$(readlink $a); \
337 rm -f $a; \
338 echo .so ${m##*/} > $a; \
339 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
340 done; \
f3f40db8 341 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
cd33aab7
AM
342 fi; \
343 done; \
91bfff1c
JB
344 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
345 echo "Compress info pages: %{_infodir}"; \
346 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
347 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
348 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
026ed59b 349 fi; \
f67bd19e 350}; __spec_install_post_compress_docs } }
cd33aab7
AM
351
352#-----------------------------------------------------------------
353# Strip executable binaries and shared object files
354#
355# Requires: find, awk, strip, cut, xargs
356#
ee170415
JB
357# Special macros which affect this process:
358#%no_install_post_strip 1 # disable stripping at all
359#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
360#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
361#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
362#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
363#
cd33aab7 364%__spec_install_post_strip {%{!?debug: \
f67bd19e 365%{!?no_install_post_strip:__spec_install_post_strip() { \
65e03cc0 366if [ -d "$RPM_BUILD_ROOT" ]; then \
31bd34a8
ER
367 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
368 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
369 if [ "$modulelist" ]; then \
370 modulecount=$(echo "$modulelist" | wc -l); \
7f1d3873 371 printf "Stripping %d kernel modules..." $modulecount; \
6cf69412
ER
372 echo "$modulelist" | xargs -l512 chmod u+w; \
373 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
374 echo "DONE"; \
375 fi; \
31bd34a8 376 fi; \
559c4907 377 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
d65f5d0e
JB
378 if [ -n "$filelist" ]; then \
379 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
380 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
381 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
ee170415 382 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
d65f5d0e 383 if [ -n "$elfexelist" ]; then \
fefadad0 384 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
d65f5d0e
JB
385 chmod u+w $elfexelist; \
386 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
387 echo "DONE"; \
388 fi; \
389 if [ -n "$elfsharedlist" ]; then \
fefadad0 390 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
d65f5d0e
JB
391 chmod u+w $elfsharedlist; \
392 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
393 echo "DONE"; \
394 fi; \
395 if [ -n "$archiveslist" ]; then \
fefadad0 396 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
d65f5d0e
JB
397 chmod u+w $archiveslist; \
398 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
399 echo "DONE"; \
400 fi; \
65e03cc0 401 fi; \
559c4907
ER
402 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
403 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
404 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
d65f5d0e 405 if [ -n "$filelist_all" ]; then \
fefadad0 406 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
ee170415 407 chmod u+w $filelist_all; \
d65f5d0e 408 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
fc87add2 409 echo "DONE"; \
cd33aab7 410 fi; \
d65f5d0e 411 if [ -n "$filelist_unneeded" ]; then \
fefadad0 412 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
ee170415 413 chmod u+w $filelist_unneeded; \
d65f5d0e 414 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
fc87add2 415 echo "DONE"; \
5b0f0ac9 416 fi; \
d65f5d0e 417 if [ -n "$filelist_debug" ]; then \
fefadad0 418 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
ee170415 419 chmod u+w $filelist_debug; \
d65f5d0e 420 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
fc87add2 421 echo "DONE"; \
f80cefa3 422 fi; \
f67bd19e 423fi; }; __spec_install_post_strip } } }
31b569b6 424
cc545e1a 425#-----------------------------------------------------------------
426# remove all RPATH from executable binaries and shared object files
427#
428# Requires: find, awk, cut, xargs, chrpath, uname
429#
ee170415
JB
430# Special macros which affect this process
431#%no_install_post_chrpath 1 # disable chrpath at all
432#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
433#
cc545e1a 434%__spec_install_post_chrpath {%{!?debug: \
f67bd19e 435%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
f80cefa3 436if [ -d "$RPM_BUILD_ROOT" ]; then \
559c4907 437 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
65e03cc0 438 if [ -n "$files" ]; then \
0faed11b 439 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
fd3a42b0 440 fi; \
65e03cc0 441 if [ -n "$objs" ]; then \
fefadad0 442 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
65e03cc0
ER
443 echo "$objs" | \
444 while read file; do \
445 rpath= ; \
446 chmod u+w "$file"; \
447 for dir in `chrpath -l "$file" | \
448 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
449 case $dir in \
450 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
451 echo "remove-rpath: $dir in $file"; \
452 ;; \
453 * ) \
454 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
455 else rpath="$rpath:$dir" ; fi ; \
456 ;; \
457 esac ; \
458 done ; \
459 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
460 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
461 done; \
462 fi; \
f67bd19e 463fi; }; __spec_install_post_chrpath } } }
31b569b6 464
22a54b3e 465#-----------------------------------------------------------------
93b46c00 466# Find and gzip all kernel modules
467#
468# Requires: find
469#
43f81f06 470#%no_install_post_compress_modules 1
93b46c00 471%__spec_install_post_compress_modules { \
f67bd19e 472%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
9cf7c1b9 473 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
9cf7c1b9 474 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
475 if [ "$q" ]; then \
476 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
477 echo "$q" | xargs -r %{__gzip} -9nf; \
478 echo "DONE"; \
479 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
480 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
481 fi; \
31b569b6 482 fi; \
f67bd19e 483}; __spec_install_post_compress_modules } }
cd33aab7 484
e4d71427
ER
485# Remove common Perl files we don't package
486%__spec_install_post_perl_clean {\
487%{!?no_install_post_perl_clean: \
488%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
489} }
490
aad1c8e4 491#-----------------------------------------------------------------
cc6c554c 492# Update GConf2 schemas
aad1c8e4 493#
494# Requires: GConf2
495#
5b8ed3c0 496%gconf_schema_install() \
31b569b6
ER
497 umask 022; \
498 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
499 %{nil}
5b8ed3c0 500
501%gconf_schema_uninstall() \
429d047e 502if [ $1 = 0 ]; then \
31b569b6
ER
503 umask 022; \
504 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
429d047e 505fi \
506%{nil}
507
508#-----------------------------------------------------------------
509# Update desktop MIME database
96999189 510# requires: desktop-file-utils
429d047e 511#
9ba5542a 512%update_desktop_database_post() {{ \
429d047e 513 umask 022; \
db1adf13 514 /usr/bin/update-desktop-database -q; \
d8f5dc5b
JB
515}} \
516%{nil}
429d047e 517
38267983 518%update_desktop_database_postun() {{ \
429d047e 519if [ $1 = 0 ]; then \
520 umask 022; \
db1adf13 521 /usr/bin/update-desktop-database -q; \
429d047e 522fi \
d8f5dc5b
JB
523}} \
524%{nil}
429d047e 525
db1adf13 526#-----------------------------------------------------------------
527# Update shared MIME info database
528# requires: shared-mime-info
529#
530%update_mime_database() {{ \
531 umask 022; \
532 /usr/bin/update-mime-database %{_datadir}/mime; \
d8f5dc5b
JB
533}} \
534%{nil}
db1adf13 535
536#-----------------------------------------------------------------
537# Update icon cache
538# requires: gtk+
539#
540%update_icon_cache() {{ \
541 umask 022; \
8ffd1cc2 542 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
d8f5dc5b
JB
543}} \
544%{nil}
db1adf13 545
429d047e 546#-----------------------------------------------------------------
547# Update scrollkeeper database
548# requires: scrollkeeper
549#
550%scrollkeeper_update_post() \
429d047e 551 /usr/bin/scrollkeeper-update -q; \
552 %{nil}
553
554%scrollkeeper_update_postun() \
555if [ $1 = 0 ]; then \
429d047e 556 /usr/bin/scrollkeeper-update -q; \
557fi \
558%{nil}
559
cd33aab7
AM
560#-----------------------------------------------------------------
561# post %install sequence:
562# - autodeps exceptions
563# - compress all man and info pages,
564# - strip all ELF executables and ELF shared objects if not %debug.
5b0f0ac9 565# - compress kernel modules if any
cd33aab7
AM
566
567###################################################################
568# Requires/Provides automation
569# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
a4852742 570#
fbbdca08
JB
571%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
572%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
573%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
574%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
575%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
a4852742
JB
576#%_noautocompressdoc %{nil}
577#
5b0f0ac9
MM
578%_missing_doc_files_terminate_build 1%{nil}
579%_unpackaged_files_terminate_build %{nil}
4c7d3ba4 580# (X)emacs support
42b7e5ac 581%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
4c7d3ba4
AF
582%_emacs_lispdir %(emacs %___emacs_lispdir_helper)
583%_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
41a62699 584
984f6de6
JK
585%__php_provides %{nil}
586%__php_requires %{nil}
587%__perl_provides %{nil}
588%__perl_requires %{nil}
63b0a9d7 589%__mono_provides %{nil}
590%__mono_requires %{nil}
41a62699
AF
591
592# Perl specific macro definitions.
23c8318b
ER
593%perl_privlib %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
594%perl_archlib %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
595%perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
942c693c 596%perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
23c8318b
ER
597%perl_sitelib %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
598%perl_sitearch %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
41a62699 599
cb84f517 600# Ruby
75368847 601%ruby_archdir %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
3da52f86 602%ruby_ridir %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
75368847 603%ruby_rubylibdir %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
a800673f 604%ruby_vendorarchdir %(ruby -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)
605%ruby_vendorlibdir %(ruby -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)
75368847
ER
606%ruby_sitearchdir %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
607%ruby_sitelibdir %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
608%ruby_version %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
5483bb35
ER
609%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
610%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
cb84f517 611
3da52f86 612%php_pear_dir /usr/share/pear
9cf7051f 613%php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)
e140cc62 614%php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)
fddf0dcd 615%php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)
41a62699 616
f73da51b 617# extract php/zend api versions
fddf0dcd
ER
618%php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
619%php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)
620%php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
621%php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
622%zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
623%zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
624%zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})
6b2157a6
ER
625
626# helper macro
e255dfdc 627%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
6b2157a6
ER
628
629# macros for public use
630# for php extensions (php-pecl)
ab8d73ee 631%requires_php_extension %{__php_api_requires modules_api php_api_version} \
cc2b296f 632%{__php_api_requires zend_module_api} \
e255dfdc
ER
633%{__php_api_requires -v %php_major_version debug php_debug} \
634%{__php_api_requires -v %php_major_version thread-safety zend_zts}
ab8d73ee 635
6b2157a6
ER
636# for zend extensions
637%requires_zend_extension %{__php_api_requires zend_module_api} \
ab8d73ee 638%{__php_api_requires zend_extension_api} \
e255dfdc
ER
639%{__php_api_requires -v %php_major_version debug php_debug} \
640%{__php_api_requires -v %php_major_version thread-safety zend_zts}
6b2157a6 641
1c107a2d
ER
642# for php pdo modules (php-pecl-PDO_*)
643%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
644
e6ca24e8
ER
645# for using PHP post scripts. for PHP >= 5.0
646%php_webserver_restart \
647[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
febce2c9 648[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
b4080c85
ER
649if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
650 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
651 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
652 %service -q php-fcgi restart \
653 fi \
654fi \
e6ca24e8
ER
655%{nil}
656
657# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
658%php4_webserver_restart \
659[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
febce2c9 660[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
b4080c85
ER
661if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
662 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
663 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
664 %service -q php-fcgi restart \
665 fi \
666fi \
e6ca24e8
ER
667%{nil}
668
b89f672e
AM
669
670# X.org helper macros
04336b74 671%__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
b89f672e 672#
b444ba80
AM
673%xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
674%xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
675%xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)
676%xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
677%xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
b89f672e
AM
678
679%requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
680%{__xorg_abi_requires extension xorg_xserver_extension_abi}
681%requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
682%{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
683%requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
684%{__xorg_abi_requires font xorg_xserver_font_abi}
685%requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
686%{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
687
41a62699
AF
688# Python specific macro definitions.
689# python main version
3da52f86 690%py_ver %(python -c "import sys; print sys.version[:3]")
41a62699
AF
691
692# directories
31b569b6
ER
693%py_prefix %(python -c "import sys; print sys.prefix")
694%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
a4f0b5e0 695%py_scriptdir %{py_prefix}/share/python%{py_ver}
31b569b6 696%py_incdir /usr/include/python%{py_ver}
3da52f86 697%py_sitedir %{py_libdir}/site-packages
a4f0b5e0 698%py_sitescriptdir %{py_scriptdir}/site-packages
31b569b6 699%py_dyndir %{py_libdir}/lib-dynload
41a62699
AF
700
701# pure python modules compilation
31b569b6 702%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699 703
31b569b6 704%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699
AF
705
706# Software written in Python language require Python with main version
5177c7b1 707%pyrequires_eq() Requires: %1
41a62699 708
ea4b2900
AF
709# Hardlink binary identical .pyc and .pyo files
710# (idea by glen <at> pld-linux <dot> org)
711%__spec_install_post_py_hardlink {\
f67bd19e 712%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
ea4b2900 713[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
455bd3f1 714 b="${a%.pyc}.pyo"; \
ea4b2900
AF
715 if cmp -s "$a" "$b"; then \
716 ln -f "$a" "$b"; \
717 fi; \
718done \
f67bd19e 719}; __spec_install_post_py_hardlink } }
ea4b2900 720
16f6f416 721# remove python sources, so that check-files won't complain
ea4b2900
AF
722# (idea by glen <at> pld-linux <dot> org)
723%py_postclean() \
e4e8948b 724for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
9ba5542a 725 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
ea4b2900
AF
726done \
727%{nil}
728
67ed5b97 729# depmod macro
730%depmod() { \
fe30b3ea 731umask 022; \
67ed5b97 732if [ -e /boot/System.map-%1 ]; then \
31b569b6 733 /sbin/depmod -a -F /boot/System.map-%1 %1; \
67ed5b97 734else \
31b569b6
ER
735 if [ -e /boot/System.map ]; then \
736 /sbin/depmod -a -F /boot/System.map %1; \
737 else \
738 /sbin/depmod -a %1; \
739 fi \
67ed5b97 740fi; \
741}
742
495892af 743# XMMS specific macros
31b569b6
ER
744%xmms_prefix %(xmms-config --prefix 2>/dev/null)
745%xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null)
746%xmms_version %(xmms-config --version 2>/dev/null)
747%xmms_datadir %(xmms-config --data-dir 2>/dev/null)
748%xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null)
749%xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null)
750%xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null)
751%xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null)
752%xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null)
753%xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null)
495892af 754
bb128216
PS
755%_target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
756
e3618ee9 757# user/group checking macros
758#
759# Usage:
760# %userremove myuser
761#
762%userremove /usr/lib/rpm/user_group.sh user del
763%groupremove /usr/lib/rpm/user_group.sh group del
764#
765# Usage:
766# if %usertestrm myuser; then
767# /usr/sbin/userdel -r myuser
768# Note:
769# use these macros only if you need to call userdel/groupdel with
770# a non-standard option or take an extra action; otherwise use the
771# %userremove/%groupremove macros
772#
773%usertestrm /usr/lib/rpm/user_group.sh user testrm
774%grouptestrm /usr/lib/rpm/user_group.sh group testrm
13f70a2c
JK
775# user group membership management macros
776#
777# Usage:
778# %addusertogroup myuser agroup
779#
780%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
bfd9689c 781
782# banner support (useful in {pre,post}{,un} and triggers)
783#
784# Usage:
a980efc1 785# %banner name [-a] [-e] [-n] [-tn] <<EOF
bfd9689c 786# the banner text, the banner text
a980efc1
ER
787# the banner text, and following line
788#EOF
789# You can use any form of here-document, <<'EOF' <<-EOT will do.
790# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
791#
bfd9689c 792# -a - append to the banner
fb033326 793# -e - send to stderr instead of stdout
1257c400 794# -n - no show banner (overrides -t)
795# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
4055114a
ER
796#
797# Tests:
798# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
799# rpm -E 'date | %banner -e banner' > m; sh -x m
800#
8bea2501 801%banner(aent:) ( \
f1bbc6ff 802RPM_SCRIPTVERBOSITY=5 \
803[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
804if [ -x /usr/bin/banner.sh ]; then \
a980efc1 805 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
f1bbc6ff 806else \
fb033326 807 CMD="cat%{-e: >&2}" \
f1bbc6ff 808fi \
4055114a
ER
809eval $CMD %{?2:%2}%{?3: %3}) \
810%{nil}
1257c400 811
3c972982 812# useradd/groupadd macros
1ebc460a 813# Author: Elan Ruusamäe <glen@pld-linux.org>
29c5556c
ER
814#
815# Usage:
816# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
817# [-g initial_group] [-G group[,...]] login
818#
819# -u uid. REQUIRED
820# -g gid/group. REQUIRED
821# -s defaults to /bin/false
822# -d defaults to /usr/share/empty
823# -c No default
824# -r is accepted but ignored (it's always set)
6eb25d5d 825# -k skeleton dir. defaults to /usr/share/empty
29c5556c
ER
826# rpm specific flags
827# -P package name. defaults to %{name}
828#
29c5556c 829%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
0044d46f
ER
830%{!-u:%{error:useradd: Required argument -u missing}} \
831%{!-g:%{error:useradd: Required argument -g missing}} \
832%{!?1:%{error:useradd: Required parameter login missing}} \
29c5556c
ER
833if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
834 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
835 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
836 exit 1 \
837 fi \
838else \
839 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
840 /usr/sbin/useradd \\\
cc333c8b 841 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
29c5556c
ER
842 -u %{-u*} \\\
843 -r \\\
844 -d %{-d*}%{!-d:/usr/share/empty} \\\
845 -s %{-s*}%{!-s:/bin/false} \\\
85e3e9a1 846 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
29c5556c
ER
847 -g %{-g*} \\\
848 %{-M} \\\
849 %{-G:-G %{-G*}} \\\
6750d9f5 850 %{expand:%{%{#}}} 1>&2 || exit $? \
52e30914 851 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
29c5556c
ER
852fi;
853
29c5556c
ER
854# Usage:
855# %groupadd [-P package] [-g gid] group
856#
857# -g gid. REQUIRED
858#
859# Sample:
860# %groupadd -P %{name}-base -g %{gid} %{name}
861
862%groupadd(g:P:rfo) \
0044d46f
ER
863%{!-g:%{error:groupadd: Required argument -g missing}} \
864%{!?1:%{error:groupadd: Required parameter group missing}} \
29c5556c
ER
865if [ -n "`/usr/bin/getgid %{1}`" ]; then \
866 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
867 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
868 exit 1 \
869 fi \
870else \
871 echo "Adding group %{1} GID=%{-g*}." \
6750d9f5 872 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
52e30914 873 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
29c5556c 874fi;
053b8de1 875
55a50f1a 876# webapp macros
1ebc460a 877# Author: Elan Ruusamäe <glen@pld-linux.org>
ba42a822
ER
878#
879# The config is installed/removed inside trigger, this means that you can any
880# time install apache1/apache/lighttpd package and the configuration file is
43f81f06 881# updated. if you don't need the config for various reason for specific
ba42a822
ER
882# webserver, just remove the symlink from config directory using webapp
883# program. the trigger will not recreate the symlink on upgrades. In other
884# words the config is linked to webserver config directory on first install of
885# PACKAGE or WEBSERVER.
886#
55a50f1a
ER
887# Add package's webserver config to webserver webapps dir.
888# Usage:
217f2cb2 889# %webapp_register WEBSERVER WEBAPP
ba42a822
ER
890#
891%webapp_register() \
892%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
893if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
894 /usr/sbin/webapp register %1 %2\
895fi\
973c1dc7 896# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
afe4f5f0 897if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
5f0b2e29 898 %{expand:%service -q %%1 reload}\
ba42a822
ER
899fi\
900%{nil}
901
902# Remove package's config from webserver webapps dir.
ba42a822 903# Usage:
b9588fe6
ER
904# %webapp_register [-f] WEBSERVER WEBAPP
905%webapp_unregister(f) \
ba42a822
ER
906%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
907# remove link if either of the packages are gone \
afe4f5f0 908if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
217f2cb2 909 /usr/sbin/webapp unregister %1 %2\
5f0b2e29 910 %{expand:%service -q %%1 reload}\
ba42a822
ER
911fi \
912%{nil}
913
8edf8498 914# service macro.
1ebc460a 915# Author: Elan Ruusamäe <glen@pld-linux.org>
8edf8498
ER
916#
917# calls usual service restart on package %post, but skips the restart if
918# administrator has disabled automatic service restarts in either global
919# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
920#
8edf8498 921# Usage:
524e081b 922# %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
8edf8498 923#
dd4e969a 924# -q be silent when service isn't started (for scriplets restaring other package's services)
8edf8498 925#
e42cbd35 926%service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
cec3a041
ER
927
928
91bd3172
ER
929# Java macros. based on jpackage macros.java
930#
931# Root directory where all Java VMs/SDK/JREs are installed.
93406dd9 932%_jvmdir %{_libdir}/jvm
91bd3172
ER
933
934# Root directory where all Java VMs/SDK/JREs expose their jars
93406dd9 935%_jvmjardir %{_libdir}/jvm-exports
91bd3172
ER
936
937# Root directory for all Java VM/SDK/JRE's private things.
938%_jvmprivdir %{_libdir}/jvm-private
939
940# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
93406dd9 941%_jvmlibdir %{_libdir}/jvm
91bd3172
ER
942
943# Root directory for all architecture independent parts of Java VM/SDK/JRE's
944%_jvmdatadir %{_datadir}/jvm
945
946# Root directory for all configurations parts of Java VM/SDK/JRE's
947%_jvmsysconfdir %{_sysconfdir}/jvm
948
949# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
29959405 950%_jvmcommonlibdir %{_libdir}/jvm-common
91bd3172
ER
951
952# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
29959405 953%_jvmcommondatadir %{_datadir}/jvm-common
91bd3172
ER
954
955# Root directory for all common configurations parts of Java VM/SDK/JRE's
29959405 956%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
91bd3172
ER
957
958# Directory where arch-specific (JNI) version-independent jars are installed.
93406dd9 959%_jnidir %{_libdir}/java
91bd3172 960
e7b2fcef 961%java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
cec3a041 962
43f81f06
ER
963%ant JAVA_HOME=%{java_home} ant
964%jar %{java_home}/bin/jar
e7b2fcef 965%java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
43f81f06
ER
966%javac %{java_home}/bin/javac
967%javadoc %{java_home}/bin/javadoc
cec3a041 968
43f81f06 969%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
cec3a041
ER
970
971%jpackage_script() \
a2047fce
ER
972install -d $RPM_BUILD_ROOT%{_bindir}\
973cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
cec3a041
ER
974#!/bin/sh\
975#\
976# %{name} script\
977# JPackage Project <http://www.jpackage.org/>\
978\
979# Source functions library\
980. %{_javadir}-utils/java-functions\
981\
982# Source system prefs\
a2047fce 983if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
43f81f06 984 . %{_sysconfdir}/java/%{name}.conf\
cec3a041
ER
985fi\
986\
987# Source user prefs\
a2047fce
ER
988if [ -f $HOME/.%{name}rc ]; then\
989 . $HOME/.%{name}rc\
cec3a041
ER
990fi\
991\
992# Configuration\
993MAIN_CLASS=%1\
994BASE_FLAGS=%2\
995BASE_OPTIONS=%3\
a2047fce 996BASE_JARS="%(echo %4 | tr ':' ' ')"\
cec3a041
ER
997\
998# Set parameters\
999set_jvm\
a2047fce
ER
1000set_classpath $BASE_JARS\
1001set_flags $BASE_FLAGS\
1002set_options $BASE_OPTIONS\
cec3a041
ER
1003\
1004# Let's start\
a2047fce 1005run "$@"\
cec3a041
ER
1006EOF
1007
d449d2c8
ER
1008# jpackage 1.7
1009# Directory for maven depmaps
1010#
1011%_mavendepmapdir /etc/maven
1012%_mavendepmapfragdir /etc/maven/fragments
1013
1014#
1015# add_to_depmap adds an entry to the depmap. The arguments are:
1016#
1017# %1 the original groupid
1018# %2 the original artifact id
1019# %3 the version
1020# %4 the new groupid
1021# %5 the new artifactid
1022#
1023
1024%add_to_maven_depmap() \
1025install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1026cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1027<dependency>\
1028 <maven>\
1029 <groupId>%1</groupId>\
1030 <artifactId>%2</artifactId>\
1031 <version>%3</version>\
1032 </maven>\
1033 <jpp>\
1034 <groupId>%4</groupId>\
1035 <artifactId>%5</artifactId>\
1036 <version>%3</version>\
1037 </jpp>\
1038</dependency>\
1039\
1040EOF\
1041%{nil}
1042
1043#==============================================================================
1044#
1045# update_maven_depmap updates the main maven depmap
1046#
1047%update_maven_depmap() \
1048echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1049if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1050cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1051fi\
1052echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1053
1054
e22fc3d1 1055# PEAR install macros
1ebc460a 1056# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1057#
1058# Usage:
1059# %%pear_package_setup [-a #] [-n FMT]
1060#
e22fc3d1 1061# -a # - also unpack SOURCE#. for PEAR bootstrapping
d2a29d34 1062# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
e22fc3d1 1063# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
d2a29d34
ER
1064#
1065# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1066# destination hierarchy. you should copy the tree to buildroot after
1067# patching/reorganizing with %%pear_package_install.
1068#
1069# additionally BUILDROOT is stripped from files and files are converted to UNIX
1070# line endings.
1071#
1072# the pear install process output is recorded to install.log, you should put it
a4f06f46 1073# to %%doc for later debug or just for information.
d2a29d34
ER
1074#
1075# additionally additional-packages.txt is produced if it was detected that the
1076# package has optional dependencies. the file format is suitable of displaying
1077# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1078# automatically added for this file.
e22fc3d1
ER
1079
1080
1081# records install.log and transforms PEAR names to PLD Linux rpm package names.
1082%__pear_install_log \
1083tee install.log \
1084# make post message of optional packages \
1085grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1086if [ -s optional-packages.txt ]; then \
1087 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1088else \
1089 rm -f optional-packages.txt \
1090fi \
1091%{nil}
1092
1093# command invoking pear cli
1094%__pear /usr/bin/pear
1095
856feeea 1096%pear_install(a:n:zD) \
e22fc3d1
ER
1097%__pear \\\
1098 -c pearrc \\\
d2a29d34
ER
1099 -d doc_dir=/docs \\\
1100 -d php_dir=%{php_pear_dir} \\\
1101 -d bin_dir=%{_bindir} \\\
1102 -d data_dir=%{php_pear_dir}/data \\\
1103 -d test_dir=%{php_pear_dir}/tests \\\
1104 install \\\
e22fc3d1 1105 --packagingroot=%{builddir} \\\
d2a29d34
ER
1106 --offline \\\
1107 --nodeps \\\
1108 %{-f:--force} \\\
856feeea
ER
1109 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1110%{nil}
1111
1112# The main macro.
1113# using this macro will append optional-packages.txt to the nocompressdoc list
1114# as it's displayed to user after package install. and adding additional gzip
1115# dep is just waste ;)
1116%pear_package_setup(a:n:zD) \
1117%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1118%define builddir %{_builddir}/%{srcdir} \
1119%setup -q -c -T %{-D:-D} -n %{srcdir} \
1120%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1121%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1122%pear_install \
e22fc3d1
ER
1123%{-z:cd ..} \
1124cat %{-z:$_N/}.install.log | %__pear_install_log \
1125\
d2a29d34 1126# undos sources \
07fa2259 1127find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
d2a29d34
ER
1128%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1129%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1130%{nil}
1131
0aced28c 1132# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1ebc460a 1133# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1134%pear_package_install() \
1135cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1136find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1137# help the developer out a little: \
1138if [ -f _noautoreq ]; then \
1139 echo "AutoReqdep detected:" \
1140 echo "_noautoreq $(cat _noautoreq)" \
1141fi \
1142%{nil}
1143
54294c49
ER
1144
1145# Register OpenLDAP schema.
1ebc460a 1146# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1147#
1148# Usage:
1149# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1150#
1151# -d specify dependant schemas, separated by comma
1152#
1153%openldap_schema_register(d:) \
1154for schema in %*; do \
1155 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1156 %{__sed} -i -e " \
1157 /^include.*local.schema/{ \
1158 iinclude\\t $schema\
1159 } \
1160 " /etc/openldap/slapd.conf \
1161 fi \
1162done \
1163# enable dependant schemas \
1164if [ "%{-d*}" ]; then \
1165 %{__sed} -i -e ' \
1166 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1167 s/^#// \
1168 }' /etc/openldap/slapd.conf \
1169fi \
1170%{nil}
1171
1172# Unregister OpenLDAP schema.
1ebc460a 1173# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1174#
1175# Usage:
1176# %%openldap_schema_unregister %{schemadir}/horde.schema
1177#
1178%openldap_schema_unregister() \
1179for schema in %*; do \
1180 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1181 %{__sed} -i -e " \
1182 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1183 # for symmetry it would be nice if we disable enabled schemas in post, \
1184 # but we really can not do that, it would break something else. \
1185 " /etc/openldap/slapd.conf \
1186 fi \
1187done \
1188%{nil}
1189
feb61fae 1190%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
6ee06092 1191
a4623211 1192
1193# Build modules for kernels 2.6
1194# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1195#
1196# Usage:
650cc681 1197# %build_kernel_modules -m <modules> -C <directory>
a4623211 1198#
1199# remember that proper Makefile is still required
1200# Options:
3c972982 1201# -m <modules> (required) -- comma-separated list of modules to save,
a4623211 1202# without .ko extension, may be placed in subdirectory
650cc681 1203# -C <directory> -- change to <directory> before doing anything
a4623211 1204# -p <arg>, -P <arg> -- arguments passeed to make scripts
bf97e3a6 1205# -c -- do not execute make clean
a4623211 1206# <additional arguments> -- all additional arguments will be passed to
1207# make modules
1208#
1209# Additional patching supported via here document. Try:
1210# %build_kernel_modules -m module <<'EOF'
1211# your patch script here
1212# EOF
1213# Don't use it unless patching depends on config options.
1214
1215# Developer note: don't touch it unless you know how to handle '\'.
1216# - \ in script expands to nothing
1217# - \\\ in script expands to \
8ad8b353 1218# - \\\ inside definition expands to nothing
a4623211 1219# - \\\\\\\ inside definition expands to \
1220# - in last line \ has to touch arguments so arguments passing
1221# in new lines (using \) will be supported
1222
bf97e3a6 1223%build_kernel_modules(p:P:m:C:c) \
a4623211 1224%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1225 \
1226%define Opts \\\\\\\
1227%if "%{_target_base_arch}" != "%{_arch}" \\\
1228 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
4d45063a 1229 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
a4623211 1230 %else \\\
1231 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1232 %endif \\\
1233%else \\\
4d45063a 1234 CC="%{kgcc}" \\\
a4623211 1235%endif \
4d45063a 1236%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
a4623211 1237 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1238 \
8b51c37f 1239%{?-C:cd %{-C*}} \
a4623211 1240compile() { \
1241 L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1242 set -e -x \
d606f9ca 1243 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1244 \
d606f9ca 1245for cfg in ${cfgs:-dist}; do \
a4623211 1246 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1247 \
8e042a98 1248 rm -rf o \
a4623211 1249 install -d o/include/linux \
1250 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1251 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1252 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1253 \
1254 set +x \
1255 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1256 set -x \
1257 \
1258 %if %{with dist_kernel} \
1259 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1260 %{-p*} %{-P*} \\\
1261 %{MakeOpts} \
1262 %else \
1263 install -d o/include/config \
1264 touch o/include/config/MARKER \
1265 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1266 %endif \
1267 \
bf97e3a6 1268 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
a4623211 1269 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
bf97e3a6 1270 M=$PWD %{MakeOpts}} \
a4623211 1271 %{__make} -C %{_kernelsrcdir} modules \\\
1272 ${1+"$@"} \\\
1273 M=$PWD %{MakeOpts} \
1274 \
1275 for MODULE in {%{-m*},}; do \
1276 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1277 done \
1278done \
650cc681 1279%{?-C:cd -} \
a4623211 1280} \
1281compile %{*}\
1282%{nil}
1283
1284
1285# Install kernel modules built by %build_kernel_modules
1286# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1287#
1288# Usage:
1289# %install_kernel_modules -m <modules> -d <directory>
1290#
1291# Options:
3c972982 1292# -m <modules> (required) -- comma-separated list of modules to install,
a4623211 1293# without .ko extension, may be placed in subdirectory
1294# -d <directory> (required) -- in what subdirectory modules should be
1295# installed (eg. misc, kernel/drivers/net)
1296# -s <suffix> -- suffix to use when installing modules, useful when module
1297# with same name exists in kernel already
1298# -n <file> -- name of modprobe config file to use (without .conf extension)
c4bd6177 1299# for defining aliases, only useful with -s
a4623211 1300
1301%install_kernel_modules(m:d:s:n:) \
1302%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1303%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1304%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1305 \
1306%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1307%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
c6bb8dfe 1308 \
d606f9ca 1309local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1310 \
1311for MODULE in {%{-m*},}; do \
1312 [ -n "${MODULE}" ] || continue \
d606f9ca
ER
1313 for cfg in ${cfgs:-dist}; do \
1314 [ "$cfg" = smp ] && suf=smp || suf= \
1315 MNAME=${MODULE##*/} \
1316 install -D ${MODULE}-$cfg.ko \\\
1317 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b37738c0 1318 %{?-s:install -d %{ModprobeD}$suf \
d606f9ca
ER
1319 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1320 >> %{ModprobeD}$suf/%{-n*}.conf} \
1321 done \
a4623211 1322done \
1323%{nil}
1324
16516cbd 1325# patchset macros
1ebc460a 1326# Author: Elan Ruusamäe <glen@pld-linux.org>
16516cbd
ER
1327#
1328# Usage:
1329# %patchset_source -f <seq(1) format> <start> [<end>]
1330# %patchset_patch <start> [<end>]
1331#
1332# If <end> is omited, it is assumed to be <start>.
1333#
1334# For example in preamble:
1335# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1336# and in %prep:
1337# %patchset_patch 33 44
1338
1339# generate SourceX urls from range START STOP
1340# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1341# The sources start from 10000
cc2d394a 1342%patchset_source(f:b:) %(
8c40a202 1343 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1344 start=$(expr $base + %1);
1345 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1346 # we need to call seq twice as it doesn't allow two formats
1347 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1348 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1349 paste %{tmpdir}/__ps{1,2};
1350 rm -f %{tmpdir}/__ps{1,2};
3b7f1777
ER
1351) \
1352%{nil}
16516cbd
ER
1353
1354# apply sources from %patchset_source
1355# -p specify -pX for %patch line
1356# -b base offset: defaults to 10000
1357%patchset_patch(f:p:b:) %(
8c40a202 1358 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1359 start=$(expr $base + %1);
1360 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1361 echo ": patchset_patch %1%{?2: to %2}";
1362 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
3b7f1777
ER
1363) \
1364%{nil}
16516cbd 1365
c7cb683a 1366# browser plugins v2
1ebc460a 1367# Author: Elan Ruusamäe <glen@pld-linux.org>
c7cb683a
ER
1368#
1369# Usage:
1370# %browser_plugins_add_browser <name> -p <plugindir>
1371#
1372# <name> (required) -- name of the browser. usually %{name}.
1373# -p <plugindir> (required) -- in what directory browser searches for its plugins.
825d0960
ER
1374# -b -- default blacklists
1375# -a <arch> override arch
c7cb683a
ER
1376#
1377# Example:
1378# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1379
1380%_browserpluginsconfdir /etc/browser-plugins
292d3658 1381%_browserpluginsdir %{_libdir}/browser-plugins
c7cb683a
ER
1382%update_browser_plugins /usr/sbin/update-browser-plugins || :
1383
825d0960 1384%browser_plugins_add_browser(p:b:a:) \
2ac4652b 1385 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
c7cb683a 1386 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
825d0960
ER
1387 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1388 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
c7cb683a
ER
1389 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1390 %{-b:cat >> $blacklist_file %{-b*}} \
1391%{nil}
1392
c879189d
ER
1393# Helper for LUA.
1394# split string separated by space into quoted list
1395#
1ebc460a 1396# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1397#
1398# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1399%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1400
1401# adjust /etc/shells by adding and removing shells from there
1ebc460a 1402# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1403#
1404# Usage:
1405# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1406# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1407#
1408# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1409
1410%add_etc_shells(p) %{-p:<lua>}\
1411t = {}\
1412f = io.open("/etc/shells", "r")\
1413if f then\
1414 for l in f:lines() do t[l]=l; end\
1415 f:close()\
1416end\
1417for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1418 if not t[s] then\
b566b93e 1419 print("Adding "..s.." to /etc/shells")\
c879189d
ER
1420 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1421 end\
1422end\
1423%{nil}
1424
1425%remove_etc_shells(p) %{-p:<lua>}\
b566b93e 1426%{-p:if arg[2] == 0 then}\
39e5924d
ER
1427 t = {}\
1428 f = io.open("/etc/shells", "r")\
1429 if f then\
1430 for l in f:lines() do t[l]=l; end\
1431 f:close()\
1432 end\
1433 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
b566b93e 1434 print("Removing "..l.." from /etc/shells")\
39e5924d
ER
1435 t[l] = nil\
1436 end\
1437 s=""\
1438 for _, l in pairs(t) do\
1439 s=s..l.."\\n"\
1440 end\
1441 io.open("/etc/shells", "w"):write(s)\
1442%{-p:end} \
c879189d
ER
1443%{nil}
1444
e22fc3d1 1445# vim:ts=4 sw=4 noet syn=spec
This page took 0.53404 seconds and 4 git commands to generate.